import logging
import threading

import transitions
from transitions.extensions import GraphMachine
from transitions.extensions.states import add_state_features, Timeout

import rospy
from std_msgs.msg import String

from .skillset import SkillsetInterface

class ConnectPythonLoggingToROS(logging.Handler):

    MAP = {
        logging.DEBUG:rospy.logdebug,
        logging.INFO:rospy.loginfo,
        logging.WARNING:rospy.logwarn,
        logging.ERROR:rospy.logerr,
        logging.CRITICAL:rospy.logfatal
    }

    def emit(self, record):
        try:
            self.MAP[record.levelno]("%s: %s" % (record.name, record.getMessage()))
        except KeyError:
            rospy.logerr("unknown log level %s LOG: %s: %s" % (record.levelno, record.name, record.msg))

#reconnect logging calls which are children of this to the ros log system
logging.getLogger('transitions').addHandler(ConnectPythonLoggingToROS())

{% for sk in skills|sort %}
class {{ sk.name|action_name }}State(Timeout):
    def __init__(self, name, timeout=0, **kwargs):
        super().__init__(name, on_enter='on_enter_{{ sk.name }}', timeout=timeout, 
            on_exit='on_exit_{{ sk.name }}', on_timeout='on_exit_{{ sk.name }}')
        self.__args = kwargs

    @property
    def args(self):
        return self.__args
{% endfor %}

@add_state_features(Timeout)
class {{ skillset.name|data_name }}Machine(GraphMachine):

    def __init__(self, name, namespace='', export=None, publish=False, **kwargs):
        super().__init__(show_conditions=True, send_event=True, 
                         after_state_change='export_machine',
                         queued=True,
                         **kwargs)
        self.__skillset = SkillsetInterface(namespace=namespace, **kwargs)
        self.__export = export
        self.__publish = publish
        self.__pub = rospy.Publisher(name, String, queue_size=1)

    def export_machine(self, event: transitions.EventData = None):
        if self.__export:
            self.get_graph().draw(self.__export, prog='dot')
        if self.__publish:
            self.__pub.publish(String(data=self.get_graph().string()))

    {% for sk in skills|sort %}
    # {{ sk.name }}
    def on_enter_{{ sk.name }}(self, event: transitions.EventData):
        rospy.logdebug("[{{ sk.name }} on_enter] wait {{ sk.name }} manager to be active")
        self.__skillset.skills.{{ sk.name }}.wait_manager(timeout=event.kwargs.get('timeout', 0))
        rospy.logdebug("[{{ sk.name }} on_enter] starting {{ sk.name }}")
        goal = event.kwargs
        goal.update(event.state.args)
        self.__skillset.skills.{{ sk.name }}.start(**goal)
        t = threading.Thread(target=self.__wait_{{ sk.name }}, args=[event])
        t.start()

    def __wait_{{ sk.name }}(self, event: transitions.EventData):
        self.__skillset.skills.{{ sk.name }}.wait()
        result = self.__skillset.skills.{{ sk.name }}.result
        try:
            rospy.logdebug("[{{ sk.name }} wait] trigger %s", result)
            return self.trigger(result, **event.kwargs)
        except:
            pass
        try:
            rospy.logdebug("[{{ sk.name }} wait] trigger ERROR")
            return self.trigger('ERROR', **event.kwargs)
        except:
            pass

    def on_exit_{{ sk.name }}(self, event: transitions.EventData):
        if self.__skillset.skills.{{ sk.name }}.running:
            rospy.logdebug("[{{ sk.name }} on_exit] interrupt {{ sk.name }}")
            self.__skillset.skills.{{ sk.name }}.interrupt()
            rospy.logdebug("[{{ sk.name }} on_exit] wait interruption of {{ sk.name }}")
        #return self.__wait_{{ sk.name }}()
    {% endfor %}

    {% for r in resources|sort %}
    # {{ r.name }}
    {% for s in r.statemachine.states|sort %}
    def is_{{ r.name }}_{{ s }}(self, event: transitions.EventData):
        return self.__skillset.resources.{{ r.name }}.get() == '{{ s }}'
    {% endfor %}
    {% endfor %}
